=== debian/changelog ===
eiskaltdcpp (2.0.3-1) unstable; urgency=low

  * Update to stable release of EiskaltDC++ 2.0.3.

 -- Boris Pek <tehnick-8@mail.ru>  Tue, 08 Jun 2010 21:55:18 +0400

eiskaltdcpp (2.0.2-1) unstable; urgency=low

  * Update to stable release of EiskaltDC++ 2.0.2.

 -- Boris Pek <tehnick-8@mail.ru>  Thu, 13 May 2010 11:25:06 +0400

eiskaltdcpp (2.0.1-1) unstable; urgency=low

  * Initial release (closes: #540458).

 -- Boris Pek <tehnick-8@mail.ru>  Tue, 27 Apr 2010 01:40:10 +0400
