=== debian/control ===
Source: eiskaltdcpp
Section: net
Priority: optional
Maintainer: Boris Pek <tehnick-8@mail.ru>
Build-Depends: debhelper (>= 7), cmake (>= 2.6.0), autotools-dev, fakeroot,
 libqt4-dev (>=4.4.0), qt4-dev-tools (>=4.4.0), qt4-qtconfig (>=4.4.0),
 libboost-dev | libboost1.42-dev | libboost1.40-dev | libboost1.39-dev | libboost1.38-dev | libboost1.37-dev | libboost1.35-dev,
 libbz2-dev, zlib1g-dev, pkg-config, libupnp3-dev, libssl-dev, libaspell-dev
Homepage: http://code.google.com/p/eiskaltdc/
Standards-Version: 3.8.4

Package: eiskaltdcpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: php5-cli
Replaces: eiskaltdcpp-unstable
Conflicts: eiskaltdcpp-unstable
Description: EiskaltDC++ is graphical client for Direct Connect
 EiskaltDC++ is a program for UNIX-like systems that uses the Direct Connect
 and ADC protocol. It is compatible with other DC clients, such as the original
 DC from Neomodus, DC++ and derivatives. EiskaltDC++ also interoperates with
 all common DC hub software.
