=== debian/rules ===
#!/usr/bin/make -f

NCPUS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)

ifeq ($(NCPUS),-1)
	NCPUS:=1
endif

ifeq ($(NCPUS),0)
	NCPUS:=1
endif

PKG_NAME = eiskaltdcpp

CMAKEOPTS =	-DUSE_ASPELL:BOOL=1 \
			-DFREE_SPACE_BAR_C:BOOL=1 \
			-DCMAKE_INSTALL_PREFIX=/usr \
			./

configure: configure-stamp
configure-stamp:
	dh_testdir
	cmake $(CMAKEOPTS)
	cp ChangeLog.txt changelog
	touch $@
build: configure build-stamp
build-stamp:
	dh_testdir
	$(MAKE) -j$(NCPUS)
	touch $@
clean: do-clean
do-clean:
	dh_testdir
	dh_testroot
	[ ! -f Makefile ] || $(MAKE) DESTDIR=$(CURDIR)/debian/$(PKG_NAME) clean
	dh_clean
install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) install DESTDIR=debian/$(PKG_NAME)
binary-indep: build install
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs changelog
	dh_installdocs
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb
binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure patch unpatch do-clean
